MepCalculation
Date: 2019-10-22

org.jmol.quantum

## Class MepCalculation

- java.lang.Object
- - org.jmol.quantum.QuantumCalculation
  - - org.jmol.quantum.MepCalculation

- Direct Known Subclasses:
    MlpCalculation

      public class MepCalculation
      extends QuantumCalculation

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private javajs.util.P3[]` | `atomCoordAngstroms`
    `private javajs.util.BS` | `bsSelected`
    `protected int` | `distanceMode`
    `protected static int` | `E_MINUS_D`
    `protected static int` | `E_MINUS_D_OVER_2`
    `protected java.util.Map<java.lang.String,java.lang.Object>` | `htAtomicPotentials`
    `protected static int` | `ONE_OVER_D`
    `protected static int` | `ONE_OVER_ONE_PLUS_D`
    `private float[]` | `potentials`
    `protected java.lang.String` | `resourceName`
    `private Viewer` | `vwr`

    - ### Fields inherited from class org.jmol.quantum.QuantumCalculation

      `atomIndex, bohr_per_angstrom, bsExcluded, countsXYZ, doDebug, firstAtomOffset, integration, nX, nY, nZ, originBohr, points, qmAtoms, rangeBohrOrAngstroms, stepBohr, thisAtom, unitFactor, volume, voxelData, voxelDataTemp, X, X2, xBohr, xMax, xMin, Y, Y2, yBohr, yMax, yMin, Z, Z2, zBohr, zMax, zMin`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MepCalculation()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `assignPotentials(Atom[] atoms, float[] potentials, javajs.util.BS bsAromatic, javajs.util.BS bsCarbonyl, javajs.util.BS bsIgnore, java.lang.String data)`
    `void` | `calculate(VolumeData volumeData, javajs.util.BS bsSelected, javajs.util.P3[] xyz, Atom[] atoms, float[] potentials, int calcType)`
    `void` | `createCube()`
    `protected void` | `getAtomicPotentials(java.lang.String data, java.lang.String resourceName)`
    `protected float` | `getTabulatedPotential(Atom atom)`
    `float` | `getValueAtPoint(javajs.util.P3 pt)`
    `protected void` | `process()`
    `void` | `set(Viewer vwr)`
    `void` | `setup(int calcType, float[] potentials, javajs.util.P3[] atomCoordAngstroms, javajs.util.BS bsSelected)`
    `float` | `valueFor(float x0, float d2, int distanceMode)`

    - ### Methods inherited from class org.jmol.quantum.QuantumCalculation

      `getIntegration, initialize, initialize0, initializeOnePoint, initializeOnePointQC, processPoints, processPt, setMinMax, setupCoordinates, setXYZBohr`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ONE_OVER_D

          protected static final int ONE_OVER_D

      See Also:
        Constant Field Values

    - #### E_MINUS_D_OVER_2

          protected static final int E_MINUS_D_OVER_2

      See Also:
        Constant Field Values

    - #### ONE_OVER_ONE_PLUS_D

          protected static final int ONE_OVER_ONE_PLUS_D

      See Also:
        Constant Field Values

    - #### E_MINUS_D

          protected static final int E_MINUS_D

      See Also:
        Constant Field Values

    - #### distanceMode

          protected int distanceMode

    - #### potentials

          private float[] potentials

    - #### atomCoordAngstroms

          private javajs.util.P3[] atomCoordAngstroms

    - #### bsSelected

          private javajs.util.BS bsSelected

    - #### vwr

          private Viewer vwr

    - #### htAtomicPotentials

          protected java.util.Map<java.lang.String,java.lang.Object> htAtomicPotentials

    - #### resourceName

          protected java.lang.String resourceName

  - ### Constructor Detail

    - #### MepCalculation

          public MepCalculation()

  - ### Method Detail

    - #### set

          public void set(Viewer vwr)

    - #### assignPotentials

          public void assignPotentials(Atom[] atoms,
                                       float[] potentials,
                                       javajs.util.BS bsAromatic,
                                       javajs.util.BS bsCarbonyl,
                                       javajs.util.BS bsIgnore,
                                       java.lang.String data)

      Parameters:
        `atoms` -
        `potentials` -
        `bsAromatic` -
        `bsCarbonyl` -
        `bsIgnore` -
        `data` -

    - #### setup

          public void setup(int calcType,
                            float[] potentials,
                            javajs.util.P3[] atomCoordAngstroms,
                            javajs.util.BS bsSelected)

    - #### calculate

          public void calculate(VolumeData volumeData,
                                javajs.util.BS bsSelected,
                                javajs.util.P3[] xyz,
                                Atom[] atoms,
                                float[] potentials,
                                int calcType)

    - #### getValueAtPoint

          public float getValueAtPoint(javajs.util.P3 pt)

    - #### process

          protected void process()

      Specified by:
        `process` in class `QuantumCalculation`

    - #### valueFor

          public float valueFor(float x0,
                                float d2,
                                int distanceMode)

    - #### getTabulatedPotential

          protected float getTabulatedPotential(Atom atom)

    - #### getAtomicPotentials

          protected void getAtomicPotentials(java.lang.String data,
                                             java.lang.String resourceName)

    - #### createCube

          public void createCube()

      Specified by:
        `createCube` in class `QuantumCalculation`